package be.iminds.ilabt.jfed.lowlevel.connection;

import be.iminds.ilabt.jfed.lowlevel.JFedException;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.*;
import be.iminds.ilabt.jfed.util.JFedTrustStore;
import org.apache.xmlrpc.XmlRpcClient;
import org.slf4j.Logger;

import java.net.URL;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.cert.X509Certificate;

/**
 * SfaSslWithClientAuthConnection: XmlRpc over HTTPs, which doesn't use SSL with client authentication
 * THIS IS NOT A NORMAL SFA CONNECTION. This is only used for GetVersion etc...
 */
public class BasicSfaConnection extends SfaConnection {
    /**
     * Create a connection by specifying all low level details needed.
     *
     * @throws be.iminds.ilabt.jfed.lowlevel.JFedException
     */
    public BasicSfaConnection(ConnectionConfig connectionConfig,
                              HttpInfoXmlRpcTransportFactory xmlRpcTransportFactory,
                              XmlRpcClient xmlRpcClient) throws JFedException {
        super(connectionConfig);

        this.xmlRpcTransportFactory = xmlRpcTransportFactory;
        this.xmlRpcClient = xmlRpcClient;
    }

    public void close() {
        error = true;
        xmlRpcTransportFactory.clearLastCallData();
        xmlRpcTransportFactory.close();
        xmlRpcTransportFactory = null;
        xmlRpcClient = null;
    }
}